package formen;

import java.awt.Color;
import java.awt.Graphics;
import javax.swing.JComponent;

public abstract class Form {

    Punkt refPunkt;
    Color farbe;

    public Color getFarbe() {
        return farbe;
    }

    public void setFarbe(Color farbe) {
        this.farbe = farbe;
    }

    public Form() {
    }

    public Form(Punkt refPunkt) {
        this.refPunkt = refPunkt;
    }

    public Form(double x, double y) {
        this.refPunkt = new Punkt(x, y);
    }

    public Punkt getRefPunkt() {
        return refPunkt;
    }

    public void setRefPunkt(Punkt refPunkt) {
        this.refPunkt = refPunkt;
    }

    abstract double getFlaeche();
    
    abstract double getUmfang();

    abstract void verschieben(Punkt vektor);
    
    abstract void drehen(double winkel);
    
    abstract void zeichnen(Graphics g);
}
